api/urls.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from django.conf import settings
from django.urls import include, path
from rest_framework import routers

from .viewsets import UserViewSet

# Routers provide an easy way of automatically determining the URL conf.
# Register each app API router and user viewset
router = routers.DefaultRouter()
router.register('user', UserViewSet)

if "logs" in settings.INSTALLED_APPS:
    from logs.api.urls import register_logs_urls
    register_logs_urls(router, "logs")

if "participation" in settings.INSTALLED_APPS:
    from participation.api.urls import register_participation_urls
    register_participation_urls(router, "participation")

if "registration" in settings.INSTALLED_APPS:
    from registration.api.urls import register_registration_urls
    register_registration_urls(router, "registration")

app_name = 'api'

# Wire up our API using automatic URL routing.
# Additionally, we include login URLs for the browsable API.
urlpatterns = [
    path('', include(router.urls)),
    path('api-auth/', include('rest_framework.urls', namespace='rest_framework')),
]

participation/api/urls.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from .views import NoteViewSet, ParticipationViewSet, PassageViewSet, PoolViewSet, \
    SolutionViewSet, TeamViewSet, TournamentViewSet, TweakViewSet, WrittenReviewViewSet


def register_participation_urls(router, path):
    """
    Configure router for participation REST API.
    """
    router.register(path + "/note", NoteViewSet)
    router.register(path + "/participation", ParticipationViewSet)
    router.register(path + "/passage", PassageViewSet)
    router.register(path + "/pool", PoolViewSet)
    router.register(path + "/review", WrittenReviewViewSet)
    router.register(path + "/solution", SolutionViewSet)
    router.register(path + "/team", TeamViewSet)
    router.register(path + "/tournament", TournamentViewSet)
    router.register(path + "/tweak", TweakViewSet)

participation/urls.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from django.urls import path

from .views import CreateTeamView, FinalNotationSheetTemplateView, GSheetNotificationsView, JoinTeamView, \
    MyParticipationDetailView, MyTeamDetailView, NotationSheetsArchiveView, NoteUpdateView, ParticipationDetailView, \
    PassageDetailView, PassageUpdateView, PoolCreateView, PoolDetailView, PoolJuryView, PoolNotesTemplateView, \
    PoolPresideJuryView, PoolRemoveJuryView, PoolUpdateView, PoolUploadNotesView, \
    ScaleNotationSheetTemplateView, SelectTeamFinalView, \
    SolutionsDownloadView, SolutionUploadView, \
    TeamAuthorizationsView, TeamDetailView, TeamLeaveView, TeamListView, TeamUpdateView, \
    TeamUploadMotivationLetterView, TournamentCreateView, TournamentDetailView, TournamentExportCSVView, \
    TournamentHarmonizeNoteView, TournamentHarmonizeView, TournamentListView, TournamentPaymentsView, \
    TournamentPublishNotesView, TournamentUpdateView, WrittenReviewUploadView


app_name = "participation"

urlpatterns = [
    path("create_team/", CreateTeamView.as_view(), name="create_team"),
    path("join_team/", JoinTeamView.as_view(), name="join_team"),
    path("teams/", TeamListView.as_view(), name="team_list"),
    path("team/", MyTeamDetailView.as_view(), name="my_team_detail"),
    path("team/<int:pk>/", TeamDetailView.as_view(), name="team_detail"),
    path("team/<int:pk>/update/", TeamUpdateView.as_view(), name="update_team"),
    path("team/<int:pk>/upload-motivation-letter/", TeamUploadMotivationLetterView.as_view(),
         name="upload_team_motivation_letter"),
    path("team/<int:team_id>/authorizations/", TeamAuthorizationsView.as_view(), name="team_authorizations"),
    path("team/leave/", TeamLeaveView.as_view(), name="team_leave"),
    path("detail/", MyParticipationDetailView.as_view(), name="my_participation_detail"),
    path("detail/<int:pk>/", ParticipationDetailView.as_view(), name="participation_detail"),
    path("detail/<int:pk>/solution/", SolutionUploadView.as_view(), name="upload_solution"),
    path("detail/<int:team_id>/solutions/", SolutionsDownloadView.as_view(), name="participation_solutions"),
    path("tournament/", TournamentListView.as_view(), name="tournament_list"),
    path("tournament/create/", TournamentCreateView.as_view(), name="tournament_create"),
    path("tournament/<int:pk>/", TournamentDetailView.as_view(), name="tournament_detail"),
    path("tournament/<int:pk>/update/", TournamentUpdateView.as_view(), name="tournament_update"),
    path("tournament/<int:pk>/payments/", TournamentPaymentsView.as_view(), name="tournament_payments"),
    path("tournament/<int:pk>/csv/", TournamentExportCSVView.as_view(), name="tournament_csv"),
    path("tournament/<int:tournament_id>/authorizations/", TeamAuthorizationsView.as_view(),
         name="tournament_authorizations"),
    path("tournament/<int:tournament_id>/solutions/", SolutionsDownloadView.as_view(),
         name="tournament_solutions"),
    path("tournament/<int:tournament_id>/written_reviews/", SolutionsDownloadView.as_view(),
         name="tournament_written_reviews"),
    path("tournament/<int:tournament_id>/notation/sheets/", NotationSheetsArchiveView.as_view(),
         name="tournament_notation_sheets"),
    path("tournament/<int:pk>/notation/notifications/", GSheetNotificationsView.as_view(),
         name="tournament_gsheet_notifications"),
    path("tournament/<int:pk>/publish-notes/<int:round>/", TournamentPublishNotesView.as_view(),
         name="tournament_publish_notes"),
    path("tournament/<int:pk>/harmonize/<int:round>/", TournamentHarmonizeView.as_view(),
         name="tournament_harmonize"),
    path("tournament/<int:pk>/harmonize/<int:round>/<str:action>/<str:trigram>/", TournamentHarmonizeNoteView.as_view(),
         name="tournament_harmonize_note"),
    path("tournament/<int:pk>/select-final/<int:participation_id>/", SelectTeamFinalView.as_view(),
         name="select_team_final"),
    path("pools/create/", PoolCreateView.as_view(), name="pool_create"),
    path("pools/<int:pk>/", PoolDetailView.as_view(), name="pool_detail"),
    path("pools/<int:pk>/update/", PoolUpdateView.as_view(), name="pool_update"),
    path("pools/<int:pool_id>/solutions/", SolutionsDownloadView.as_view(), name="pool_download_solutions"),
    path("pools/<int:pool_id>/written_reviews/", SolutionsDownloadView.as_view(), name="pool_download_written_reviews"),
    path("pools/<int:pk>/notation/scale/", ScaleNotationSheetTemplateView.as_view(), name="pool_scale_note_sheet"),
    path("pools/<int:pk>/notation/final/", FinalNotationSheetTemplateView.as_view(), name="pool_final_note_sheet"),
    path("pools/<int:pool_id>/notation/sheets/", NotationSheetsArchiveView.as_view(), name="pool_notation_sheets"),
    path("pools/<int:pk>/jury/", PoolJuryView.as_view(), name="pool_jury"),
    path("pools/<int:pk>/jury/remove/<int:jury_id>/", PoolRemoveJuryView.as_view(), name="pool_remove_jury"),
    path("pools/<int:pk>/jury/preside/<int:jury_id>/", PoolPresideJuryView.as_view(), name="pool_preside"),
    path("pools/<int:pk>/upload-notes/", PoolUploadNotesView.as_view(), name="pool_upload_notes"),
    path("pools/<int:pk>/upload-notes/template/", PoolNotesTemplateView.as_view(), name="pool_notes_template"),
    path("pools/passages/<int:pk>/", PassageDetailView.as_view(), name="passage_detail"),
    path("pools/passages/<int:pk>/update/", PassageUpdateView.as_view(), name="passage_update"),
    path("pools/passages/<int:pk>/written_review/", WrittenReviewUploadView.as_view(), name="upload_written_review"),
    path("pools/passages/notes/<int:pk>/", NoteUpdateView.as_view(), name="update_notes"),
]

registration/urls.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

from django.urls import path

from .views import AddOrganizerView, AdultPhotoAuthorizationTemplateView, ChildPhotoAuthorizationTemplateView, \
    InstructionsTemplateView, MyAccountDetailView, ParentalAuthorizationTemplateView, \
    PaymentHelloAssoReturnView, PaymentRedirectHelloAssoView, PaymentUpdateGroupView, PaymentUpdateView, \
    ResetAdminView, SignupView, UserDetailView, UserImpersonateView, UserListView, UserResendValidationEmailView, \
    UserUpdateView, UserUploadHealthSheetView, UserUploadParentalAuthorizationView, UserUploadPhotoAuthorizationView, \
    UserUploadVaccineSheetView, UserValidateView, UserValidationEmailSentView

app_name = "registration"

urlpatterns = [
    path("signup/", SignupView.as_view(), name="signup"),
    path("add-organizer/", AddOrganizerView.as_view(), name="add_organizer"),
    path('validate_email/sent/', UserValidationEmailSentView.as_view(), name='email_validation_sent'),
    path('validate_email/resend/<int:pk>/', UserResendValidationEmailView.as_view(),
         name='email_validation_resend'),
    path('validate_email/<uidb64>/<token>/', UserValidateView.as_view(), name='email_validation'),
    path("user/", MyAccountDetailView.as_view(), name="my_account_detail"),
    path("user/<int:pk>/", UserDetailView.as_view(), name="user_detail"),
    path("user/<int:pk>/update/", UserUpdateView.as_view(), name="update_user"),
    path("user/<int:pk>/upload-photo-authorization/", UserUploadPhotoAuthorizationView.as_view(),
         name="upload_user_photo_authorization"),
    path("user/<int:pk>/upload-photo-authorization/final/", UserUploadPhotoAuthorizationView.as_view(),
         name="upload_user_photo_authorization_final"),
    path("parental-authorization-template/", ParentalAuthorizationTemplateView.as_view(),
         name="parental_authorization_template"),
    path("photo-authorization-template/adult/", AdultPhotoAuthorizationTemplateView.as_view(),
         name="photo_authorization_adult_template"),
    path("photo-authorization-template/child/", ChildPhotoAuthorizationTemplateView.as_view(),
         name="photo_authorization_child_template"),
    path("instructions-template/", InstructionsTemplateView.as_view(), name="instructions_template"),
    path("user/<int:pk>/upload-health-sheet/", UserUploadHealthSheetView.as_view(),
         name="upload_user_health_sheet"),
    path("user/<int:pk>/upload-vaccine-sheet/", UserUploadVaccineSheetView.as_view(),
         name="upload_user_vaccine_sheet"),
    path("user/<int:pk>/upload-parental-authorization/", UserUploadParentalAuthorizationView.as_view(),
         name="upload_user_parental_authorization"),
    path("user/<int:pk>/upload-parental-authorization/final/", UserUploadParentalAuthorizationView.as_view(),
         name="upload_user_parental_authorization_final"),
    path("update-payment/<int:pk>/", PaymentUpdateView.as_view(), name="update_payment"),
    path("update-payment/<int:pk>/toggle-group-mode/", PaymentUpdateGroupView.as_view(),
         name="update_payment_group_mode"),
    path("update-payment/<int:pk>/hello-asso/", PaymentRedirectHelloAssoView.as_view(), name="payment_hello_asso"),
    path("update-payment/<int:pk>/hello-asso/return/", PaymentHelloAssoReturnView.as_view(),
         name="payment_hello_asso_return"),
    path("user/<int:pk>/impersonate/", UserImpersonateView.as_view(), name="user_impersonate"),
    path("user/list/", UserListView.as_view(), name="user_list"),
    path("reset-admin/", ResetAdminView.as_view(), name="reset_admin"),
]

tfjm/urls.py
# Copyright (C) 2020 by Animath
# SPDX-License-Identifier: GPL-3.0-or-later

"""tfjm URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/3.0/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.conf import settings
from django.contrib import admin
from django.urls import include, path
from django.utils.translation import gettext_lazy as _
from django.views.defaults import bad_request, page_not_found, permission_denied, server_error
from django.views.generic import TemplateView
from participation.views import MotivationLetterView
from registration.views import HealthSheetView, ParentalAuthorizationView, PhotoAuthorizationView, \
    ReceiptView, SolutionView, VaccineSheetView, WrittenReviewView

from .views import AdminSearchView

urlpatterns = [
    path('', TemplateView.as_view(template_name=f"index_{settings.TFJM_APP.lower()}.html",
                                  extra_context={'title': _("Home")}),
         name='index'),
    path('about/', TemplateView.as_view(template_name="about.html"), name='about'),
    path('i18n/', include('django.conf.urls.i18n')),
    path('admin/doc/', include('django.contrib.admindocs.urls')),
    path('admin/', admin.site.urls, name="admin"),
    path('accounts/', include('django.contrib.auth.urls')),
    path('search/', AdminSearchView.as_view(), name="haystack_search"),

    path('api/', include('api.urls')),
    path('chat/', include('chat.urls')),
    path('draw/', include('draw.urls')),
    path('participation/', include('participation.urls')),
    path('registration/', include('registration.urls')),

    path('media/authorization/photo/<str:filename>/', PhotoAuthorizationView.as_view(),
         name='photo_authorization'),
    path('media/authorization/health/<str:filename>/', HealthSheetView.as_view(),
         name='health_sheet'),
    path('media/authorization/vaccine/<str:filename>/', VaccineSheetView.as_view(),
         name='vaccine_sheet'),
    path('media/authorization/parental/<str:filename>/', ParentalAuthorizationView.as_view(),
         name='parental_authorization'),
    path('media/authorization/receipt/<str:filename>/', ReceiptView.as_view(),
         name='receipt'),
    path('media/authorization/motivation_letters/<str:filename>/', MotivationLetterView.as_view(),
         name='motivation_letter'),

    path('media/solutions/<str:filename>/', SolutionView.as_view(),
         name='solution'),
    path('media/reviews/<str:filename>/', WrittenReviewView.as_view(),
         name='reviews'),
]

if settings.DEBUG:
    # Serve static files in DEBUG mode
    import django.contrib.staticfiles.urls
    urlpatterns += django.contrib.staticfiles.urls.urlpatterns

handler400 = bad_request
handler403 = permission_denied
handler404 = page_not_found
handler500 = server_error

participation/templates/participation/team_detail.html
{% extends "base.html" %}

{% load i18n %}
{% load crispy_forms_filters %}

{% block content %}
    <div class="card bg-body shadow">
        <div class="card-header text-center">
            <h4>{{ team.name }}</h4>
        </div>
    <div class="card-body">
        <dl class="row">
            <dt class="col-sm-6 text-sm-end">{% trans "Name:" %}</dt>
            <dd class="col-sm-6">{{ team.name }}</dd>

            <dt class="col-sm-6 text-sm-end">{% trans "Trigram:" %}</dt>
            <dd class="col-sm-6">{{ team.trigram }}</dd>

            <dt class="col-sm-6 text-sm-end">{% trans "Email:" %}</dt>
            <dd class="col-sm-6"><a href="mailto:{{ team.email }}">{{ team.email }}</a></dd>

            <dt class="col-sm-6 text-sm-end">{% trans "Access code:" %}</dt>
            <dd class="col-sm-6">{{ team.access_code }}</dd>

            <dt class="col-sm-6 text-sm-end">{% trans "Coaches:" %}</dt>
            <dd class="col-sm-6">
                {% for coach in team.coaches.all %}
                    <a href="{% url "registration:user_detail" pk=coach.user.pk %}">{{ coach }}</a>{% if not forloop.last %},{% endif %}
                {% empty %}
                    {% trans "any" %}
                {% endfor %}
            </dd>

            <dt class="col-sm-6 text-sm-end">{% trans "Participants:" %}</dt>
            <dd class="col-sm-6">
                {% for student in team.students.all %}
                    <a href="{% url "registration:user_detail" pk=student.user.pk %}">{{ student }}</a>{% if not forloop.last %},{% endif %}
                {% empty %}
                    {% trans "any" %}
                {% endfor %}
            </dd>

            <dt class="col-sm-6 text-sm-end">{% trans "Tournament:" %}</dt>
            <dd class="col-sm-6">
                {% if team.participation.tournament %}
                    <a href="{% url "participation:tournament_detail" pk=team.participation.tournament.pk %}">{{ team.participation.tournament }}</a>
                {% else %}
                    {% trans "any" %}
                {% endif %}
            </dd>

            <dt class="col-sm-6 text-sm-end">{% trans "Photo authorizations:" %}</dt>
            <dd class="col-sm-6">
                {% for participant in team.participants.all %}
                    {% if participant.photo_authorization %}
                        <a href="{{ participant.photo_authorization.url }}">{{ participant }}</a>{% if not forloop.last %},{% endif %}
                    {% else %}
                        {{ participant }} ({% trans "Not uploaded yet" %}){% if not forloop.last %},{% endif %}
                    {% endif %}
                {% endfor %}
            </dd>

            {% if team.participation.final %}
                <dt class="col-sm-6 text-sm-end">{% trans "Photo authorizations (final):" %}</dt>
                <dd class="col-sm-6">
                    {% for participant in team.participants.all %}
                        {% if participant.photo_authorization_final %}
                            <a href="{{ participant.photo_authorization_final.url }}">{{ participant }}</a>{% if not forloop.last %},{% endif %}
                        {% else %}
                            {{ participant }} ({% trans "Not uploaded yet" %}){% if not forloop.last %},{% endif %}
                        {% endif %}
                    {% endfor %}
                </dd>
            {% endif %}

            {% if not team.participation.tournament.remote %}
                {% if TFJM.HEALTH_SHEET_REQUIRED %}
                    <dt class="col-sm-6 text-sm-end">{% trans "Health sheets:" %}</dt>
                    <dd class="col-sm-6">
                        {% for student in team.students.all %}
                            {% if student.under_18 %}
                                {% if student.health_sheet %}
                                    <a href="{{ student.health_sheet.url }}">{{ student }}</a>{% if not forloop.last %},{% endif %}
                                {% else %}
                                    {{ student }} ({% trans "Not uploaded yet" %}){% if not forloop.last %},{% endif %}
                                {% endif %}
                            {% endif %}
                        {% endfor %}
                    </dd>
                {% endif %}

                {% if TFJM.VACCINE_SHEET_REQUIRED %}
                    <dt class="col-sm-6 text-sm-end">{% trans "Vaccine sheets:" %}</dt>
                    <dd class="col-sm-6">
                        {% for student in team.students.all %}
                            {% if student.under_18 %}
                                {% if student.vaccine_sheet %}
                                    <a href="{{ student.vaccine_sheet.url }}">{{ student }}</a>{% if not forloop.last %},{% endif %}
                                {% else %}
                                    {{ student }} ({% trans "Not uploaded yet" %}){% if not forloop.last %},{% endif %}
                                {% endif %}
                            {% endif %}
                        {% endfor %}
                    </dd>
                {% endif %}

                <dt class="col-sm-6 text-sm-end">{% trans "Parental authorizations:" %}</dt>
                <dd class="col-sm-6">
                    {% for student in team.students.all %}
                        {% if student.under_18 %}
                            {% if student.parental_authorization %}
                                <a href="{{ student.parental_authorization.url }}">{{ student }}</a>{% if not forloop.last %},{% endif %}
                            {% else %}
                                {{ student }} ({% trans "Not uploaded yet" %}){% if not forloop.last %},{% endif %}
                            {% endif %}
                        {% endif %}
                    {% endfor %}
                </dd>

                {% if team.participation.final %}
                    <dt class="col-sm-6 text-sm-end">{% trans "Parental authorizations (final):" %}</dt>
                    <dd class="col-sm-6">
                        {% for student in team.students.all %}
                            {% if student.under_18_final %}
                                {% if student.parental_authorization_final %}
                                    <a href="{{ student.parental_authorization_final.url }}">{{ student }}</a>{% if not forloop.last %},{% endif %}
                                {% else %}
                                    {{ student }} ({% trans "Not uploaded yet" %}){% if not forloop.last %},{% endif %}
                                {% endif %}
                            {% endif %}
                        {% endfor %}
                    </dd>
                {% endif %}
            {% endif %}

            {% if TFJM.MOTIVATION_LETTER_REQUIRED %}
                <dt class="col-sm-6 text-sm-end">{% trans "Motivation letter:" %}</dt>
                <dd class="col-sm-6">
                    {% if team.motivation_letter %}
                        <a href="{{ team.motivation_letter.url }}">{% trans "Download" %}</a>
                    {% else %}
                        <em>{% trans "Not uploaded yet" %}</em>
                    {% endif %}
                    {% if user.registration.team == team and not user.registration.team.participation.valid or user.registration.is_admin %}
                        <button class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#uploadMotivationLetterModal">{% trans "Replace" %}</button>
                    {% endif %}
                </dd>
            {% endif %}

        {% if user.registration.is_volunteer %}
            {% if user.registration in self.team.participation.tournament.organizers or user.registration.is_admin %}
                <div class="text-center">
                    <a class="btn btn-info" href="{% url "participation:team_authorizations" team_id=team.id %}">
                        <i class="fas fa-file-archive"></i> {% trans "Download all submitted authorizations" %}
                    </a>
                </div>
            {% endif %}
        {% endif %}

        {% if team.participation.valid %}
            <hr class="my-3">
            {% for student in team.students.all %}
                {% for payment in student.payments.all %}
                    <dt class="col-sm-6 text-sm-end">
                        {% trans "Payment of" %} {{ student }}
                        {% if payment.grouped %}({% trans "grouped" %}){% endif %}
                        {% if payment.final %} ({% trans "final" %}){% endif %} :
                    </dt>
                    <dd class="col-sm-6">
                        Valide : {{ payment.valid|yesno }}
                        {% if payment.valid is False or user.registration.is_volunteer %}
                            {% if user.registration in payment.registrations.all or user.registration.is_coach or user.registration.is_volunteer %}
                                <a href="{% url "registration:update_payment" pk=payment.pk %}" class="btn btn-secondary">
                                    <i class="fas fa-money-bill-wave"></i> {% trans "Update payment" %}
                                </a>
                            {% endif %}
                        {% endif %}
                    </dd>
                {% endfor %}
            {% endfor %}
        {% endif %}
        </dl>
    </div>
    <div class="card-footer text-center">
        <button class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#updateTeamModal">{% trans "Update" %}</button>
        {% if not team.participation.valid %}
            <button class="btn btn-danger" data-bs-toggle="modal" data-bs-target="#leaveTeamModal">{% trans "Leave" %}</button>
        {% endif %}
    </div>
    </div>

    <hr>

    {% if team.participation.valid %}
        <div class="text-center">
            <a class="btn btn-info" href="{% url "participation:participation_detail" pk=team.participation.pk %}">
                <i class="fas fa-file-pdf"></i> {% trans "Access to team participation" %}
            </a>
        </div>
    {% elif team.participation.valid == None %} {# Team did not ask for validation #}
        {% if user.registration.participates %}
            {% if can_validate %}
                <div class="alert alert-info">
                    {% trans "Your team has at least 4 members and a coach and all authorizations were given: the team can be validated." %}
                    <div class="text-center">
                        <form method="post">
                            {% csrf_token %}
                            {{ request_validation_form|crispy }}
                            <button class="btn btn-success" name="request-validation">{% trans "Submit my team to validation" %}</button>
                        </form>
                    </div>
                </div>
            {% else %}
                <div class="alert alert-warning">
                    {% trans "Your team must be composed of 4 members and a coach and each member must upload their authorizations and confirm its email address." %}
                </div>
            {% endif %}
        {% else %}
            <div class="alert alert-warning">
            {% trans "This team didn't ask for validation yet." %}
            </div>
        {% endif %}
    {% else %}  {# Team is waiting for validation #}
        {% if user.registration.participates %}
            <div class="alert alert-warning">
                {% trans "Your validation is pending." %}
            </div>
        {% else %}
            <div class="alert alert-info">
                {% trans "The team requested to be validated. You may now control the authorizations and confirm that they can participate." %}
            </div>
             <form method="post">
                {% csrf_token %}
                {{ validation_form|crispy }}
                <div class="input-group btn-group">
                    <button class="btn btn-success" name="validate" type="submit">{% trans "Validate" %}</button>
                    <button class="btn btn-danger" name="invalidate" type="submit">{% trans "Invalidate" %}</button>
                </div>
             </form>
        {% endif %}
    {% endif %}

    {% if TFJM.MOTIVATION_LETTER_REQUIRED %}
        {% trans "Upload motivation letter" as modal_title %}
        {% trans "Upload" as modal_button %}
        {% url "participation:upload_team_motivation_letter" pk=team.pk as modal_action %}
        {% include "base_modal.html" with modal_id="uploadMotivationLetter" modal_enctype="multipart/form-data" %}
    {% endif %}

    {% trans "Update team" as modal_title %}
    {% trans "Update" as modal_button %}
    {% url "participation:update_team" pk=team.pk as modal_action %}
    {% include "base_modal.html" with modal_id="updateTeam" %}

    {% trans "Leave team" as modal_title %}
    {% trans "Leave" as modal_button %}
    {% url "participation:team_leave" as modal_action %}
    {% include "base_modal.html" with modal_id="leaveTeam" modal_button_type="danger" %}
{% endblock %}

{% block extrajavascript %}
    <script>
        document.addEventListener('DOMContentLoaded', () => {
            {% if TFJM.MOTIVATION_LETTER_REQUIRED %}
              initModal("uploadMotivationLetter", "{% url "participation:upload_team_motivation_letter" pk=team.pk %}")
            {% endif %}
            initModal("updateTeam", "{% url "participation:update_team" pk=team.pk %}")
            initModal("leaveTeam", "{% url "participation:team_leave" %}")
        })
    </script>
{% endblock %}

participation/templates/participation/tournament_list.html
{% extends request.content_only|yesno:"empty.html,base.html" %}

{% load django_tables2 i18n %}

{% block content-title %}
    <h1>{% trans "All tournaments" %}</h1>
{% endblock %}

{% block content %}
    <div id="form-content">
        {% render_table table %}
        {% if user.registration.is_admin %}
            <div class="d-grid">
                <a class="btn gap-0 btn-success" href="{% url "participation:tournament_create" %}">{% trans "Add tournament" %}</a>
            </div>
        {% endif %}
    </div>
{% endblock %}

participation/templates/participation/upload_notes.html
{% extends request.content_only|yesno:"empty.html,base.html" %}

{% load crispy_forms_tags %}
{% load i18n %}

{% block content %}
    <form method="post" enctype="multipart/form-data">
        <div id="form-content">
            <div class="alert alert-warning">
                {% url 'participation:pool_jury' pk=pool.jury as jury_url %}
                {% blocktrans trimmed with jury_url=jury_url %}
                    Rows that are full of zeros are ignored.
                    Unknown juries are not considered.
                {% endblocktrans %}
            </div>
            <div class="alert alert-info">
                <a class="alert-link" href="{% url "participation:pool_notes_template" pk=pool.pk %}">
                    {% trans "Download empty notation sheet" %}
                </a>
            </div>
            {% csrf_token %}
            {{ form|crispy }}
        </div>
        <button class="btn btn-primary" type="submit">{% trans "Upload" %}</button>
    </form>
{% endblock %}